 #cs ----------------------------------------------------------------------------
 FastFind Version: 1.3
 AutoIt Version: 3.3.6.1
 Author:         FastFrench

 Script Function:
	FastFind simple Benchmark.

#ce ----------------------------------------------------------------------------

#include "FastFind.au3"


; Use Native Pixelgetcolor() on 100 different points 
$begin = TimerInit()
for $x = 1 to 100
  $a = PixelGetcolor($x, 500);
 Next

$dif = TimerDiff($begin)

; Use Native PixelSearch() on FullScreen (1920x1080) x 100 with ShadeVariation
$begin1 = TimerInit()
for $x = 1 to 100
  $a = PixelSearch(0,0,1919,1079, 0x00FF5511, 2);
Next
$dif1 = TimerDiff($begin1)

; Processing time comparaison with FastFind equivalent : FFGetPixel, that works on a SnapShot. 
FFSnapShot() ; To keep it simple, a FullScreen capture here
$begin2 = TimerInit()
for $x = 1 to 1000
  $a = FFGetPixel($x, 500);
 Next
$dif2 = TimerDiff($begin2)

; SnapShot BenchMark : 100 SnapShots of 10x10 areas
$begin3 = TimerInit()
for $x = 1 to 100
  $a = FFSnapShot(0,0,9,9) ; 10x10 pixels area
Next
$dif3 = TimerDiff($begin3)

; SnapShot BenchMark : 100 FullScreen SnapShots
$begin4 = TimerInit()
for $x = 1 to 100
  $a = FFSnapShot() ; FullScreen Capture
Next
$dif4 = TimerDiff($begin4)


; FFNearestPixel BenchMark : 500 simple pixel search in 200x200 area
$a = FFSnapShot(0,0,199,199) ; 200x200 pixels
$begin5 = TimerInit()
for $x = 1 to 500
  $a = FFNearestPixel($x,$x,0x002545FA,false) ; Pixel search in 200x200 area, don't force SnapShots each time
Next
$dif5 = TimerDiff($begin5)

; FFNearestPixel BenchMark : 100 pixel search in FullScreen and ShadeVariation
$a = FFSnapShot() ; FullScreen
$begin52 = TimerInit()
for $x = 1 to 200
  $a = FFNearestPixel($x,$x,0x00FF5511,2)
Next
$dif52 = TimerDiff($begin52)


; FFNearestPixel BenchMark : 500 simple pixel search in 200x200 area
; SnapShot BenchMark : 100 FullScreen SnapShots
$a = FFSnapShot() ; FullScreen Capture
FFAddColor(0x453456)
FFAddColor(0xFF0034)
FFAddColor(0x76FF98)
FFAddColor(0x8723FF)
FFAddColor(0x771122)
FFAddExcludedArea(5,10,10,15)
FFAddExcludedArea(52,52,80,80)
FFAddExcludedArea(120,130,100,180)
$begin6 = TimerInit()
for $x = 1 to 100
  $a = FFNearestSpot(20, 50, 100, 100, -1, 10, false) ; With ShadeVariation, don't force SnapShots each time 
Next
$dif6 = TimerDiff($begin5)

MsgBox(0, "PixelGetColor vs FFGetPixel", "Elpased time for :"&@lf&"100 PixelGetColor = " & ($dif/1000) & " S"&@lf&"100 FullScreen PixelSearch with ShadeVariation = " & ($dif1/1000) & " S"&@lf&@lf&"1000 FFGetPixel = " & ($dif2/1000) & " S"&@lf&@lf&"100 SnapShot 10x10 area = "&($dif3/1000) & @lf&"100 FullSreen SnapShot = "&($dif4/1000) & @lf&"500 Simple Pixel Searches in 200x200 area = "&($dif5/1000) & @lf&"200 Pixel Searches with ShadeVariation in FullScreen = "&($dif52/1000) & @lf&"100 Complexe FullScreen searches (20x20 Spot, List of 5 colors with ShadeVariation and 3 excluded rectangles) = "&($dif6/1000) & @lf)


; Results : PixelGetColor x 500 = 9.61 Seconds 
;           FFGetPixel x 500    = 0.0893 Seconds